from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Int, File, String, Boolean

Mageck_Plot_V0_1_0 = CommandToolBuilder(tool="mageck_plot", base_command=["mageck", "plot"], inputs=[ToolInput(tag="in_count_table", input_type=Int(optional=True), prefix="--count-table", doc=InputDocumentation(doc="Provide a tab-separated count table instead of sam\nfiles. Each line in the table should include sgRNA\nname (1st column), gene name (2nd column) and read\ncounts in each sample.")), ToolInput(tag="in_gene_summary", input_type=File(optional=True), prefix="--gene-summary", doc=InputDocumentation(doc="The gene summary file generated by the test command.")), ToolInput(tag="in_genes", input_type=String(optional=True), prefix="--genes", doc=InputDocumentation(doc="A list of genes to be plotted, separated by comma.\nDefault: none.")), ToolInput(tag="in_samples", input_type=String(optional=True), prefix="--samples", doc=InputDocumentation(doc="A list of samples to be plotted, separated by comma.\nDefault: using all samples in the count table.")), ToolInput(tag="in_output_prefix", input_type=File(optional=True), prefix="--output-prefix", doc=InputDocumentation(doc="The prefix of the output file(s). Default sample1.")), ToolInput(tag="in_norm_method", input_type=String(optional=True), prefix="--norm-method", doc=InputDocumentation(doc="Method for normalization, including 'none' (no\nnormalization), 'median' (median normalization,\ndefault), 'total' (normalization by total read\ncounts), 'control' (normalization by control sgRNAs\nspecified by the --control-sgrna option).")), ToolInput(tag="in_control_sg_rna", input_type=String(optional=True), prefix="--control-sgrna", doc=InputDocumentation(doc="A list of control sgRNAs for normalization and for\ngenerating the null distribution of RRA.")), ToolInput(tag="in_control_gene", input_type=String(optional=True), prefix="--control-gene", doc=InputDocumentation(doc="A list of genes whose sgRNAs are used as control\nsgRNAs for normalization and for generating the null\ndistribution of RRA.")), ToolInput(tag="in_keep_tmp", input_type=Boolean(optional=True), prefix="--keep-tmp", doc=InputDocumentation(doc="Keep intermediate files."))], outputs=[ToolOutput(tag="out_output_prefix", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_prefix", type_hint=File()), doc=OutputDocumentation(doc="The prefix of the output file(s). Default sample1."))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Mageck_Plot_V0_1_0().translate("wdl", allow_empty_container=True)

